<?php
/**
 # plg_system_jvgallery - JV Gallery
 # @version		1.6.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');
jimport( 'joomla.plugin.plugin' );
jimport('joomla.filesystem.file');

class plgSystemJVGallery extends JPlugin
{
    protected $abort = array();
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	public function plgSystemJVGallery (& $subject, $config){	
		parent :: __construct($subject, $config);
	}

	public function onAfterRoute(){
		if(JRequest::getBool('jvgallery')){
			die($this->html());
		}
		 
		if(JRequest::getBool('connector')){
			die($this->connector());
		}
	}
	
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// expression to search for
		$regex = '#\[JVGALLERY\](.*?)\[\/JVGALLERY\]#i';
		preg_match_all( $regex, $article->text, $matche );
		
		if(count($matche[0])){
			foreach($matche[0] as $index => $matc){
				$replace = preg_quote($matc, '/');
				if(!in_array($matc,$this->abort)){
					$data = new JRegistry($matche[1][$index]);
					$article->text = preg_replace("/$replace/", $this->render($data), $article->text);
				}
			}
		}
	}
    
    public function resize($img, $option){
    	if(!class_exists('PhpThumbFactory') && !class_exists('GdThumb')){
    		require_once dirname(__FILE__).'/jvgallery/classes/ThumbLib.inc.php';
    	}
        $thumb_width = $option->get('options.thumb_width', '300');
        $thumb_height = $option->get('options.thumb_height', '300');
    	$replace = JURI::base(true).'/';
    	if(strpos($img, $replace) === 0){
    		$img = substr($img, strlen($replace));
    	}
    
    	// Fileinfo
    	$imgPath = realpath($img);
    	$info    = pathinfo($imgPath);
        	
    	$imgSize = @getimagesize ($img);
    	if (!is_array($imgSize)){
    		return $img;
    	}
    	
    	if($imgSize[0] < (int) $thumb_width) {
    		return $img;
    	}
            	
    	// Resize path
    	$path = JPATH_ROOT."/cache/jv/resized/".md5($thumb_width.$info['filename']).".{$info['extension']}";
    
    	if(!is_dir(dirname($path))){
    		JFolder::create(dirname($path));
    	}
    
    	if(!is_file($path)){
    		// Resize
    		$thumb = new GdThumb($img, array('jpegQuality' => isset($option->quality) ? $option->quality : 100));
    		$thumb->adaptiveResize($thumb_width, $thumb_height);
    		$thumb->save($path, $info['extension']);
    	}
    
    	return $path;
    }

    public function toURL($path) {
    	$path = str_replace(JPATH_ROOT.DIRECTORY_SEPARATOR, '', str_replace('/', DIRECTORY_SEPARATOR, $path));
    	$url = str_replace(DIRECTORY_SEPARATOR, '/', $path);
    
    	return JURI::root(true) .'/'. $url;
    }
    
    public function render($datas){
		$option = $datas->get('options');
		$images = $datas->get('images');

		if(is_array($images)){
			foreach ($images as &$img){
                if($datas->get('options.create_thumb', 1))
				    $img->thumbnail = $this->toURL($this->resize($img->img, $datas));
                else{
                    $img->thumbnail = $this->toURL($img->img);
                }
			}
		}
       
		$path = JPATH_THEMES.'/'.JFactory::getApplication()->getTemplate().'/html/plg_system_jvgallery/themes/'.$datas->get('options.theme').'/gallery.php';
        if(!is_file($path)){
        	$path = dirname(__FILE__).'/jvgallery/themes/'.$datas->get('options.theme').'/gallery.php';
        }

        $asset = $this->toUrl(dirname(__FILE__).'/jvgallery/assets');
        $doc = JFactory::getDocument();
        $doc->addScript($asset.'/js/jquery.min.js');
        $doc->addScript($asset.'/js/jquery.masonry.min.js');
        // Slimbox
        $doc->addScript($asset.'/lightboxs/slimbox/js/slimbox2.js');
        $doc->addStyleSheet($asset.'/lightboxs/slimbox/css/slimbox.css');
        // Fancybox
        $doc->addScript($asset.'/lightboxs/fancybox/jquery.mousewheel-3.0.6.pack.js');
        $doc->addScript($asset.'/lightboxs/fancybox/jquery.fancybox.pack.js');
        $doc->addScript($asset.'/lightboxs/fancybox/helpers/jquery.fancybox-buttons.js');
        $doc->addStyleSheet($asset.'/lightboxs/fancybox/jquery.fancybox.css');
        $doc->addStyleSheet($asset.'/lightboxs/fancybox/helpers/jquery.fancybox-buttons.css');
        $doc->addStyleSheet($asset.'/css/default.css');

        // Data
        $data = array();
        $data[] = 'data-gallery="jvgallery"';
        $data[] = 'data-lightbox="'.$datas->get('options.lightbox', 'fancybox').'"';
        $data[] = 'data-layout="'.$datas->get('options.layout', 'grid').'"';
        $data[] = 'data-grid="'.$datas->get('options.grid', 'fluid').'"';
        $data[] = 'data-columns="'.$datas->get('options.columns', '5').'"';
        $data[] = 'data-gutter="'.$datas->get('options.gutter', '10').'"';
        $data[] = 'data-col_width="'.$datas->get('options.col_width', '2').'"';
        if(!is_file($path)){
        	return;
        }
        
        ob_start();
            require $path;
            $html = ob_get_contents();
        ob_clean();
        
       return $html;
    }
       
    public function connector(){
    	$dir = $_POST['dir'];
    	 
    	// Filter
    	$filter = '\.png$|\.gif$|\.jpg$|\.bmp$|\.ico$|\.jpeg$|\.psd$|\.eps$';
    
    	// Get all files
    	$files   = JFolder::files(JPATH_ROOT."/{$dir}", $filter);
    	 
    	// Get all sub folders
    	$folders = JFolder::folders(JPATH_ROOT."/{$dir}", '.');
    	 
    	$html = array();
    	$html[] = '<ul class="jqueryFileTree" style="display: none;">';
    	 
    	if(is_array($folders))
    		foreach ($folders as $folder) {
    		$html[] = '<li class="directory collapsed">';;
    		$html[] = "<a href='#' rel='{$dir}{$folder}/'>$folder</a>";
    		$html[] = '</li>';
    	}
    	 
    	if(is_array($files))
    		foreach ($files as $file) {
    		$ext = preg_replace('/^.*\./', '', $file);
    		$html[] = '<li class="file ext_'.$ext.'">';
    		$html[] = "<a href='#' rel='{$dir}{$file}'>$file</a>";
    		$html[] = '</li>';
    	}
    	 
    	$html[] = '</ul>';
    
    	echo implode($html);
    
    }
    public function html(){
    	$lang = JFactory::getLanguage();
    	$lang->load('plg_system_jvgallery', JPATH_ADMINISTRATOR);
    	$dir = JRequest::getVar('dir', 'images/');
    	$url = JURI::root(true);
    	$themes = JFolder::folders(dirname(__FILE__).'/jvgallery/themes');
        include dirname(__FILE__).'/jvgallery/admin/config.php';
    }
            
}