var $JV = jQuery.noConflict();

(function($){
    window.JVGallery = {
        init: function(el){

            if(el.data('layout') == 'grid'){
                el.imagesLoaded( function(){
                    if(el.data('grid') == 'fluid'){
                        el.find('li').css({width:(el.data('col_width').toInt()) - (el.data('gutter').toInt()) + '%'});
                    }else{
                        el.find('li').css({width:(el.data('col_width').toInt()) - (el.data('gutter').toInt())});
                    }
                    el.show().masonry({
                        itemSelector : '.box',
                        columnWidth: function(containerWidth){
                            if(el.data('grid') == 'fluid'){
                                return containerWidth/el.data('columns');
                            }else{
                                return el.data('col_width');
                            }
                        },
                        isAnimated: true,
                        isRTL: $('body').css('direction') == 'rtl'
                    });
                });
            }else{

            }

            this.createLightbox(el, '');
        },

        createLightbox: function(el, options){
            switch (el.data('lightbox')){
                case 'slimbox':
                    el.find('a.handler').slimbox();
                    break;
                case 'fancybox':
                    el.find('a.handler').fancybox({
                        prevEffect		: 'fade',
                        nextEffect		: 'fade',
                        closeBtn		: false,
                        openEffect	: 'elastic',
                        closeEffect	: 'elastic',

                        helpers		: {
                            title	: { type : 'inside' },
                            buttons	: {}
                        }
                    });
                    break;
            }

        }
    };

    $(function(){
        $('*[data-gallery=jvgallery]').each(function(){
            JVGallery.init($(this));
        });
    });
})($JV);
