<?php
/**
 # com_jvsubscription - JV Subscription
 # @version		1.6.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
jimport( 'joomla.plugin.plugin' );

/**
 * Editor Image buton
 *
 * @package Editors-xtd
 * @since 1.5
 */
class plgButtonJVGallery extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param 	object $subject The object to observe
	 * @param 	array  $config  An array that holds the plugin configuration
	 * @since 1.5
	 */
	function plgButtonJVGallery(& $subject, $config)
	{
		parent::__construct($subject, $config);
	}

	/**
	 * Display the button
	 *
	 * @return array A two element array of ( imageName, textToInsert )
	 */
	function onDisplay($name)
	{
		$app  = JFactory::getApplication();
		$doc  = JFactory::getDocument();
        $lang = JFactory::getLanguage();
        $lang->load('plg_system_jvgallery');
        
        // Get content
        $getContent = $this->_subject->getContent($name);
		
        // Add script
        $doc->addScript(JURI::root().'plugins/editors-xtd/jvgallery/jvgallery/js/jvgallery-xtd.js');
        
        // Create button
		$button = new JObject();
		$button->set('modal', false);
		$button->set('onclick', "JVGalleryEditor(this, '{$name}');return false;");
		$button->set('text', JText::_('JV Gallery'));
		$button->set('name', 'image');	
		$button->set('link', '?jvgallery=1');
		$button->set('options', "{handler: 'iframe', size: {x: 800, y: 550}}");
        
        return $button;
	}
}
